DROP TABLE USER;

CREATE TABLE USER ( 
	userId			varchar(12)		NOT NULL, 
	password		varchar(12)		NOT NULL,
	name			varchar(20)		NOT NULL,
	email			varchar(50),
	phoneno1		varchar(3),
	phoneno2		varchar(4),
	phoneno3		varchar(4),
	zipcode			varchar(7),
	address			varchar(100),

	PRIMARY KEY               (userId),  	
	INDEX USERINFO_userId_idx  (userId)
);


DROP TABLE SCHEDULECODE;

CREATE TABLE SCHEDULECODE (
	schedulecode		int(6)		NOT NULL,
	weekday				varchar(3)		NOT NULL,
	startcity			varchar(10)		NOT NULL,
	starttime			varchar(14)		NOT NULL,
	arrivecity			varchar(10)		NOT NULL,
	arrivetime			varchar(14)		NOT NULL,
	airline				varchar(10)		NOT NULL,
	airplanecode		int(4)		NOT NULL,
	
	PRIMARY KEY         (schedulecode),  	
	INDEX SCHEDULECODE_schedulecode_idx  (schedulecode)	
);


DROP TABLE AIRPLANE;

CREATE TABLE AIRPLANE (
	airplanecode			int(4)		NOT NULL,
	seatno				int(3)		NOT NULL,

	PRIMARY KEY         (airplanecode)
);


insert into AIRPLANE values(1101, 200);
insert into AIRPLANE values(1103, 210);
insert into AIRPLANE values(1105, 150);
insert into AIRPLANE values(1107, 170);
insert into AIRPLANE values(1109, 220);
insert into AIRPLANE values(1111, 260);
insert into AIRPLANE values(1113, 180);
insert into AIRPLANE values(1115, 150);
insert into AIRPLANE values(1117, 240);
insert into AIRPLANE values(1119, 220);
insert into AIRPLANE values(1121, 150);
insert into AIRPLANE values(1123, 170);
insert into AIRPLANE values(1125, 190);
insert into AIRPLANE values(1127, 210);
insert into AIRPLANE values(1129, 200);
insert into AIRPLANE values(8801, 250);
insert into AIRPLANE values(8803, 220);
insert into AIRPLANE values(8805, 180);
insert into AIRPLANE values(8807, 140);
insert into AIRPLANE values(8809, 210);
insert into AIRPLANE values(8811, 230);
insert into AIRPLANE values(8813, 240);
insert into AIRPLANE values(8815, 250);
insert into AIRPLANE values(8817, 180);
insert into AIRPLANE values(8819, 190);
insert into AIRPLANE values(8821, 160);
insert into AIRPLANE values(8823, 220);
insert into AIRPLANE values(8825, 250);
insert into AIRPLANE values(8827, 230);
insert into AIRPLANE values(8829, 210);


DROP TABLE AIRPLANEFEE;

CREATE TABLE AIRPLANEFEE (
	startcity			varchar(10)		NOT NULL,
	endcity				varchar(10)		NOT NULL,	
	fee				varchar(6)		NOT NULL
);

insert into AIRPLANEFEE values('', 'λ', '53500');
insert into AIRPLANEFEE values('', '뱸', '44000'); 
insert into AIRPLANEFEE values('', '', '68500');
insert into AIRPLANEFEE values('λ', '', '55500');
insert into AIRPLANEFEE values('뱸', '', '61000');
insert into AIRPLANEFEE values('λ', '', '53500');
insert into AIRPLANEFEE values('뱸', '', '44000'); 
insert into AIRPLANEFEE values('', '', '68500');
insert into AIRPLANEFEE values('', 'λ', '55500');
insert into AIRPLANEFEE values('', '뱸', '61000');


DROP TABLE PLANESCHEDULE;

CREATE TABLE PLANESCHEDULE (
	scheduledate		varchar(8)		NOT NULL,
	schedulecode		int(6)			NOT NULL,
	restno			int(3)			NOT NULL
);

DROP TABLE SCHEDULEORDER;

CREATE TABLE SCHEDULEORDER (
	orderno			int			NOT NULL,
	userId			varchar(12)		NOT NULL,
	name			varchar(20)		NOT NULL,
	email			varchar(25)		NOT NULL,
	phoneno			varchar(15),
	scheduledate		varchar(8)		NOT NULL,
	schedulecode		int(6)			NOT NULL,
	scheduleseatno		int(3)			NOT NULL,
	totalfee		int			NOT NULL,

	PRIMARY KEY               (orderno),  	
	INDEX SCHEDULEORDER_orderno_idx   (orderno)	
);


DROP TABLE PLANEORDER;

CREATE TABLE PLANEORDER (
	orderno			int			NOT NULL,
	userId			varchar(12)		NOT NULL,
	name			varchar(20)		NOT NULL,
	email			varchar(25)		NOT NULL,
	phoneno			varchar(15),
	scheduledate		varchar(8)		NOT NULL,
	schedulecode		int(6)			NOT NULL,
	scheduleseatno		int(3)			NOT NULL,
	totalfee		int			NOT NULL,
	creditCardName		varchar(15)		NOT NULL,
	creditCardNumber	varchar(25),
	creditCardExpiryDate	varchar(10),
	juminNo			varchar(7),
	cardPassword		varchar(2),
	payPlan			int(2),
	cardOwnerName		varchar(10),
	orderDate		varchar(14),
	
	PRIMARY KEY               (orderno),  	
	INDEX PLANEORDER_orderno_idx   (orderno)	
);