package net.javajigi.abs.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.javajigi.abs.Constants;
import net.javajigi.abs.form.PlaneOrderForm;
import net.javajigi.abs.model.AirBookingService;
import net.javajigi.abs.model.CreditCardInfo;
import net.javajigi.abs.model.PlaneOrder;
import net.javajigi.abs.model.ScheduleOrder;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/** 
 * @struts.action
 * 		name="planeOrderForm"
 *      path="/paymentOrder"
 *      input="/airplane5.jsp"
 *      scope="session"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/airplane7.jsp"
 */
public class PaymentAction extends SignonAction {
	public ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		HttpSession session = request.getSession();
		PlaneOrderForm orderForm =
			(PlaneOrderForm) session.getAttribute(Constants.PLANE_ORDER);

		AirBookingService abs = AirBookingService.getInstance();
		ScheduleOrder scheduleOrder =
			abs.findScheduleOrder(orderForm.getOrderNo());

		PlaneOrder planeOrder = new PlaneOrder();
		planeOrder.setOrderNo(orderForm.getOrderNo());
		planeOrder.setScheduleSeatNo(scheduleOrder.getScheduleSeatNo());
		planeOrder.setScheduleInfo(scheduleOrder.getScheduleInfo());
		planeOrder.setUserInfo(scheduleOrder.getUserInfo());

		CreditCardInfo creditCardInfo = new CreditCardInfo();
		PropertyUtils.copyProperties(creditCardInfo, orderForm);
		planeOrder.setCreditCardInfo(creditCardInfo);

		abs.createPlaneOrder(planeOrder);

		request.setAttribute("planeOrder", planeOrder);

		return mapping.findForward("success");
	}
}
