package net.javajigi.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import net.javajigi.db.ConnectionManager;
import net.javajigi.util.DateTime;

/**
 * ڷ Խǿ ͺ̽  ϴ Ŭ.
 * BOARD, BOARDFILE ̺  Ѵ. 
 */
public class BoardDAO {
	
	/**
	 * ο Խù ߰ϴ ޽.
	 * ϳ Խù Խù ÷ε ÷ ߰.
	 */
	public int create(Board board) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer insertQuery = new StringBuffer();
			insertQuery.append("INSERT INTO BOARD ");
			insertQuery.append("(boardno, title, name, email, ");
			insertQuery.append("password, createdate, content) ");
			insertQuery.append("VALUES(?, ?, ?, ?, ?, ?, ?)");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(insertQuery.toString());

			int boardNo = getBoardNo();

			pstmt.setInt(1, boardNo);
			pstmt.setString(2, board.getTitle());
			pstmt.setString(3, board.getName());
			pstmt.setString(4, board.getEmail());
			pstmt.setString(5, board.getPassword());
			pstmt.setString(6, DateTime.getDateTimeString());
			pstmt.setString(7, board.getContent());

			int result = pstmt.executeUpdate();

			StringBuffer fileInsertQuery = new StringBuffer();
			fileInsertQuery.append("INSERT INTO BOARDFILE ");
			fileInsertQuery.append("VALUES(?, ?, ?, ?)");

			pstmt = con.prepareStatement(fileInsertQuery.toString());

			List files = board.getBoardFiles();
			Iterator fileIter = files.iterator();
			int boardFileNo = getBoardFileNo();

			while (fileIter.hasNext()) {
				BoardFile file = (BoardFile) fileIter.next();

				pstmt.setInt(1, boardFileNo);
				pstmt.setInt(2, boardNo);
				pstmt.setString(3, file.getFileName());
				pstmt.setString(4, file.getTempFileName());

				pstmt.executeUpdate();

				boardFileNo++;
				result++;
			}

			pstmt.close();
			con.close();

			return result;
		} finally {
			close(con, pstmt);
		}
	}

	/**
	 * Խù ϴ ޽.
	 * ϳ Խù Խù ÷ε ÷ ߰.
	 */
	public int update(Board board) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer updateQuery = new StringBuffer();
			updateQuery.append("UPDATE BOARD SET ");
			updateQuery.append("title=?, name=?, email=?, ");
			updateQuery.append("content=? ");
			updateQuery.append("WHERE boardno=? ");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(updateQuery.toString());
			pstmt.setString(1, board.getTitle());
			pstmt.setString(2, board.getName());
			pstmt.setString(3, board.getEmail());
			pstmt.setString(4, board.getContent());
			pstmt.setInt(5, board.getBoardNo());

			int result = pstmt.executeUpdate();

			StringBuffer fileInsertQuery = new StringBuffer();
			fileInsertQuery.append("INSERT INTO BOARDFILE ");
			fileInsertQuery.append("VALUES(?, ?, ?, ?)");

			pstmt = con.prepareStatement(fileInsertQuery.toString());

			List files = board.getBoardFiles();
			Iterator fileIter = files.iterator();
			int boardFileNo = getBoardFileNo();

			while (fileIter.hasNext()) {
				BoardFile file = (BoardFile) fileIter.next();

				String tempFileName =
					System.currentTimeMillis() + "_" + file.getFileName();
				pstmt.setInt(1, boardFileNo);
				pstmt.setInt(2, board.getBoardNo());
				pstmt.setString(3, file.getFileName());
				pstmt.setString(4, tempFileName);

				pstmt.executeUpdate();

				boardFileNo++;
				result++;
			}

			pstmt.close();
			con.close();

			return result;
		} finally {
			close(con, pstmt);
		}
	}

	/**
	 * Խù ϴ ޽.
	 */
	public int remove(int boardNo) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer removeFileQuery = new StringBuffer();
			removeFileQuery.append("DELETE FROM BOARDFILE ");
			removeFileQuery.append("WHERE boardno=?");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(removeFileQuery.toString());
			pstmt.setInt(1, boardNo);

			int result = pstmt.executeUpdate();

			StringBuffer removeQuery = new StringBuffer();
			removeQuery.append("DELETE FROM BOARD ");
			removeQuery.append("WHERE boardno=?");

			pstmt = con.prepareStatement(removeQuery.toString());
			pstmt.setInt(1, boardNo);

			result += pstmt.executeUpdate();

			pstmt.close();
			con.close();

			return result;
		} finally {
			close(con, pstmt);
		}
	}

	/**
	 * Խù ȣ شϴ Խù  ȯϴ ޽.
	 * Խù ÷εǾ ִ ÷  ȯѴ.
	 */
	public Board findBoard(int boardNo) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer findQuery = new StringBuffer();
			findQuery.append("SELECT ");
			findQuery.append("title, name, email, ");
			findQuery.append("password, createdate, content, hitcount ");
			findQuery.append("FROM BOARD ");
			findQuery.append("WHERE boardno=? ");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(findQuery.toString());
			pstmt.setInt(1, boardNo);

			rs = pstmt.executeQuery();

			Board board = null;
			if (rs.next()) {
				board = new Board();
				board.setBoardNo(boardNo);
				board.setTitle(rs.getString("title"));
				board.setName(rs.getString("name"));
				board.setEmail(rs.getString("email"));
				board.setCreateDate(rs.getString("createdate"));
				board.setPassword(rs.getString("password"));
				board.setContent(rs.getString("content"));
				board.setHitCount(rs.getInt("hitcount"));
			}

			if (board != null) {
				StringBuffer findFileQuery = new StringBuffer();

				findFileQuery.append("SELECT ");
				findFileQuery.append("fileno, filename, tempfilename ");
				findFileQuery.append("FROM BOARDFILE ");
				findFileQuery.append("WHERE boardno=? ");

				pstmt = con.prepareStatement(findFileQuery.toString());
				pstmt.setInt(1, boardNo);

				rs = pstmt.executeQuery();

				while (rs.next()) {
					BoardFile file = new BoardFile();
					file.setFileNo(rs.getInt("fileno"));
					file.setFileName(rs.getString("filename"));
					file.setTempFileName(rs.getString("tempfilename"));

					board.addBoardFile(file);
				}
			}

			rs.close();
			pstmt.close();
			con.close();

			return board;
		} finally {
			close(con, pstmt, rs);
		}
	}

	/**
	 *    īƮ  ̿Ͽ ش κ 
	 * Խù Ʈ ȯ.
	 * Խù Ʈ ÷  ʿ  Խù  ȯ
	 */
	public List findBoardList(int currentPage, int countPerPage)
		throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer findQuery = new StringBuffer();
			findQuery.append("SELECT ");
			findQuery.append("boardno, title, name, email, ");
			findQuery.append("createdate, hitcount ");
			findQuery.append("FROM BOARD ");
			findQuery.append("ORDER BY CREATEDATE DESC ");

			con = ConnectionManager.getConnection();
			pstmt =
				con.prepareStatement(
					findQuery.toString(),
					ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_READ_ONLY);

			rs = pstmt.executeQuery();

			int start = ((currentPage - 1) * countPerPage) + 1;

			List boardList = new ArrayList();
			if ((start >= 0) && rs.absolute(start)) {
				boolean hasNext = false;

				do {
					Board board = new Board();
					board.setBoardNo(rs.getInt("boardno"));
					board.setTitle(rs.getString("title"));
					board.setName(rs.getString("name"));
					board.setEmail(rs.getString("email"));
					board.setCreateDate(rs.getString("createdate"));
					board.setHitCount(rs.getInt("hitcount"));

					boardList.add(board);
				} while ((hasNext = rs.next()) && (--countPerPage > 0));
			}

			rs.close();
			pstmt.close();
			con.close();

			return boardList;
		} finally {
			close(con, pstmt, rs);
		}
	}

	/**
	 * ȸ 1 .
	 */
	public int updateHitCount(int boardNo) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer updateQuery = new StringBuffer();
			updateQuery.append("UPDATE BOARD SET ");
			updateQuery.append("hitcount=hitcount+1 ");
			updateQuery.append("WHERE boardno=? ");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(updateQuery.toString());
			pstmt.setInt(1, boardNo);

			int result = pstmt.executeUpdate();

			pstmt.close();
			con.close();

			return result;
		} finally {
			close(con, pstmt);
		}
	}

	/**
	 *  ȣ شϴ ÷ 
	 */
	public int removeBoardFile(int fileNo) throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		try {
			StringBuffer removeFileQuery = new StringBuffer();
			removeFileQuery.append("DELETE FROM BOARDFILE ");
			removeFileQuery.append("WHERE fileno=?");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(removeFileQuery.toString());
			pstmt.setInt(1, fileNo);

			int result = pstmt.executeUpdate();

			pstmt.close();
			con.close();

			return result;
		} finally {
			close(con, pstmt);
		}
	}

	private int getBoardNo() throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer maxQuery = new StringBuffer();
			maxQuery.append("SELECT max(boardno) FROM BOARD");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(maxQuery.toString());
			rs = pstmt.executeQuery();

			rs.next();

			int boardNo = rs.getInt(1) + 1;

			rs.close();
			pstmt.close();
			con.close();

			return boardNo;
		} finally {
			close(con, pstmt, rs);
		}
	}

	private int getBoardFileNo() throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer maxQuery = new StringBuffer();
			maxQuery.append("SELECT max(fileno) FROM BOARDFILE");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(maxQuery.toString());
			rs = pstmt.executeQuery();

			rs.next();
			int boardFileNo = rs.getInt(1) + 1;

			rs.close();
			pstmt.close();
			con.close();

			return boardFileNo;
		} finally {
			close(con, pstmt, rs);
		}
	}

	public int getTotalNo() throws SQLException {
		Connection con = null;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			StringBuffer maxQuery = new StringBuffer();
			maxQuery.append("SELECT count(*) FROM BOARD");

			con = ConnectionManager.getConnection();
			pstmt = con.prepareStatement(maxQuery.toString());
			rs = pstmt.executeQuery();

			rs.next();
			int totalNo = rs.getInt(1);

			rs.close();
			pstmt.close();
			con.close();

			return totalNo;
		} finally {
			close(con, pstmt, rs);
		}
	}

	private void close(Connection con, PreparedStatement pstmt, ResultSet rs)
		throws SQLException {
		if (rs != null) {
			rs.close();
		}

		close(con, pstmt);
	}

	private void close(Connection con, PreparedStatement pstmt)
		throws SQLException {
		if (pstmt != null) {
			pstmt.close();
		}

		if (con != null) {
			con.close();
		}
	}
}
