package net.javajigi.model2;

import net.javajigi.model2.action.Action;
import net.javajigi.model2.action.DeleteAction;
import net.javajigi.model2.action.IllegalCommandException;
import net.javajigi.model2.action.InsertAction;
import net.javajigi.model2.action.InsertFormAction;
import net.javajigi.model2.action.ListAction;
import net.javajigi.model2.action.LoginAction;
import net.javajigi.model2.action.LoginFormAction;
import net.javajigi.model2.action.UpdateAction;
import net.javajigi.model2.action.UpdateFormAction;
import net.javajigi.model2.action.ViewAction;

public class UserCommandFactory {

	private UserCommandFactory() {
	}

	public static UserCommandFactory getInstance() {
		return new UserCommandFactory();
	}

	/*
	 * ؾ ɾ شϴ Actionü .
	 */
	public Action getAction(String command) throws IllegalCommandException {
		Action action = null;

		if (command.equals("list")) {
			action = new ListAction();
		} else if (command.equals("view")) {
			action = new ViewAction();
		} else if (command.equals("insert")) {
			action = new InsertAction();
		} else if (command.equals("update")) {
			action = new UpdateAction();
		} else if (command.equals("delete")) {
			action = new DeleteAction();
		} else if (command.equals("login")) {
			action = new LoginAction();
		} else if (command.equals("updateForm")) {
			action = new UpdateFormAction();
		} else if (command.equals("insertForm")) {
			action = new InsertFormAction();
		} else if (command.equals("loginForm")) {
			action = new LoginFormAction();
		} else {
			throw new IllegalCommandException("߸ Դϴ. ٸ   ֽʽÿ");
		}

		return action;
	}
}
