package net.javajigi.petstore.action.cart;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.Cart;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author <a href="mailto:tchbansi@sourceforge.net">Herve Tchepannou</a>
 *
 * @struts.action
 *      name="cartForm"
 *      path="/cart"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/cart.jsp"
 */
public class CartAction extends BaseAction {
	protected ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		CartForm frm = (CartForm) form;

		Cart cart = getCart(request);

		/* Cart items */
		Collection items = cart.getCartItems();
		frm.setCartItems(items);

		/* Total */
		double total = cart.getTotal();
		frm.setTotal(total);

		return mapping.findForward(SUCCESS);
	}
}
