package net.javajigi.petstore.action.customer;

import javax.servlet.http.HttpServletRequest;

import net.javajigi.petstore.action.BaseForm;
import net.javajigi.petstore.model.domain.Account;
import net.javajigi.petstore.model.domain.Customer;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.form
 *      name="customerForm"
 */
public class CustomerForm extends BaseForm {
	private Customer _customerValue = new Customer();

	public CustomerForm() {
		_customerValue.setAccount(new Account());
	}

	public ActionErrors validate(
		ActionMapping mapping,
		HttpServletRequest request) {
		ActionErrors errors = new ActionErrors();

		Account account = getCustomerValue().getAccount();
		String userId = account.getUserId();
		String passwd = account.getPassword();
		checkNotEmpty(userId, "userId_required", errors);
		checkLength(userId, 4, "userId_length", errors);
		checkNotEmpty(passwd, "password_required", errors);
		checkLength(passwd, 4, "password_length", errors);

		checkNotEmpty(_customerValue.getEmail(), "email_required", errors);
/*		
		checkNotEmpty(
			_customerValue.getCreditCardType(),
			"ccType_required",
			errors);
		checkNotEmpty(
			_customerValue.getCreditCardNumber(),
			"ccNumber_required",
			errors);
		checkNotEmpty(
			_customerValue.getCreditCardExpiryDate(),
			"ccExpiryDate_required",
			errors);
		checkCreditCardDateFormat(
			_customerValue.getCreditCardExpiryDate(),
			"ccExpiryDate_bad_format",
			errors);
*/
		return errors;
	}

	public Customer getCustomerValue() {
		return _customerValue;
	}

	public void setCustomerValue(Customer customerValue) {
		_customerValue = customerValue;
	}
}
