package net.javajigi.petstore.action.item;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.javajigi.petstore.action.BaseAction;
import net.javajigi.petstore.model.PetStore;
import net.javajigi.petstore.model.domain.Item;
import net.javajigi.petstore.model.domain.Product;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @author <a href="mailto:tchbansi@sourceforge.net">Herve Tchepannou</a>
 *
 * @struts.action
 *      name="itemForm"
 *      path="/item"
 *      scope="request"
 *      validate="false"
 *
 * @struts.action-forward
 *      name="success"
 *      path="/item.jsp"
 */
public class ItemAction extends BaseAction {
	protected ActionForward doExecute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {
		ItemForm frm = (ItemForm) form;
		String itemId = frm.getItemId();
		PetStore petstore = getPetstore();

		/* Item */
		Item item = petstore.getItem(itemId);
		frm.setItemValue(item);

		/* Product */
		Product product = petstore.getProductByItem(itemId);
		frm.setProductValue(product);

		return mapping.findForward(SUCCESS);
	}
}
