package net.javajigi.petstore.model;

import java.util.Map;

import net.javajigi.petstore.model.domain.Category;
import net.javajigi.petstore.model.domain.Customer;
import net.javajigi.petstore.model.domain.Item;
import net.javajigi.petstore.model.domain.Order;
import net.javajigi.petstore.model.domain.Product;
import net.javajigi.petstore.util.Page;

public interface PetStore {
	public boolean authenticate( String userId, String password ) throws Exception;

	public void createCustomer( Customer customer ) throws Exception;

	public long createOrder( String userId, String orderDate, Map items ) throws Exception;
	
	public Category getCategory( String categoryId ) throws Exception;

	public Customer getCustomer( String userId ) throws Exception;

	public Item getItem( String itemId ) throws Exception;

	public Order getOrder( int orderUId ) throws Exception;

	public Product getProduct( String productId ) throws Exception;

	public Product getProductByItem( String itemId ) throws Exception;

	public Page searchProducts( java.lang.String key,int start,int count ) throws Exception;

	public void updateCustomer( Customer customer ) throws Exception;
}
