package net.javajigi.petstore.model.domain;

import java.io.Serializable;

import java.util.HashSet;
import java.util.Set;

/**
 * @hibernate.class
 *         table="T_CATEGORY"
 */
public class Category implements Serializable {
	private String _categoryId;
	private String _name;
	private String _description;
	private Set _products = new HashSet();
	/**
	 * @hibernate.id
	 *      generator-class="assigned"
	 *      length="10"
	 */
	public String getCategoryId() {
		return _categoryId;
	}

	/**
	 * @hibernate.property
	 *      length="255"
	 */
	public String getDescription() {
		return _description;
	}

	/**
	 * @hibernate.property
	 *      length="50"
	 */
	public String getName() {
		return _name;
	}

	/**
	 * @hibernate.set
	 *    role="products"
	 *    lazy="true"
	 *    cascade="delete"
	 * @hibernate.collection-key
	 *    column="category_fk"
	 * @hibernate.collection-one-to-many
	 *    class="net.javajigi.petstore.model.domain.Product"
	 */
	public Set getProducts() {
		return _products;
	}

	public void setCategoryId(String categoryId) {
		_categoryId = categoryId;
	}

	public void setDescription(String description) {
		_description = description;
	}

	public void setName(String name) {
		_name = name;
	}

	public void setProducts(Set products) {
		_products = products;
	}
}
